#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <windows.h>

using namespace std;

int main ( int argc, char* argv[] ) {
	if ( argc != 4 ) {
		cout << "Usage: ft <File> <Off> <Data>" << endl;
		return -1;
	}
	fstream file ( argv[1], ios::in | ios::out | ios::binary | ios::ate );
	if ( file.is_open() ) {
		long long fileSize = static_cast<long long> ( file.tellg() );
		cout << "Size: " << fileSize << " bytes" << endl;
		long int yPos = strtol ( argv[2], NULL, 16 );
		long int yData = strtol ( argv[3], NULL, 16 );
		unsigned char sData = static_cast<unsigned char> ( yData );
		if ( yPos < 0 || yPos >= fileSize ) {
			cout << "Overflow. [0 ~ " << fileSize - 1 << "]" << endl;
			return -1;
		}
		std::ios_base::seekdir sPos = static_cast<std::ios_base::seekdir> ( yPos );
		file.seekg ( sPos );
		char oldCbit[8], newCbit[8];
		itoa ( file.get(), oldCbit, 16 );
		itoa ( yData, newCbit, 16 );
		cout << "Data: " << oldCbit << " --> " << newCbit << endl;
		file.seekg ( sPos );
		file << sData;
		file.close();
		while ( file.is_open() )
			Sleep ( 1 );
		cout << "Tampering successfully." << endl;
		return 0;
	} else {
		cout << "Can not open file." << endl;
		return -1;
	}
}
